<%@ page import="java.io.*"%>
<%@ page import="java.util.Arrays"%>
<%@ page import="java.net.*"%>
<%@ page import="java.util.regex.*"%>

<%!

String getPackageName(){
      return "VitaraCharts";
}

String getPackageSampleChart(){
      return "VitaraHCBarChartMobile";
}

Boolean isValidURL(String strUrl) throws URISyntaxException, MalformedURLException {
      Boolean res = true;
      new URL(strUrl);
      res = !strUrl.contains(System.getProperty("line.separator"));
      return res;
}

Boolean belongsToPackage(String chart){
      Boolean result = false;
      if (chart.startsWith("Vitara") && !chart.equals(getPackageName())){
            result = true;
      }
      if (getPackageName().contains("Charts") && chart.contains("HCMapChart")) {
            result = false;
      }
      else if (getPackageName().contains("Maps") && !chart.contains("HCMapChart")) {
            result = false;
      }
      return result;
}

String getPluginsRoot(ServletContext ctx){
      return ctx.getRealPath("/") + "/plugins/";
}

String getChartsRoot(ServletContext ctx){
      return getPluginsRoot(ctx) + "VitaraCharts/";
}

String getSourceRoot(ServletContext ctx){
      return getChartsRoot(ctx) + "javascript/mojo/js/source/";
}

String getDebugFilePath(ServletContext ctx){
      return getPluginsRoot(ctx) + "VitaraHCBarChartMobile/javascript/mojo/js/source/VitaraHCBarChartMobile.js";
}

String getMobileServerFilePath(ServletContext ctx, String dir){
      String sourceDirPath = getPluginsRoot(ctx) + dir + "/javascript/mojo/js/source/";
      File ABC = new File(sourceDirPath);
      File[] list = ABC.listFiles();
      for (File aFile : list) {
            if(aFile.getName().contains("Vitara")){
                  return sourceDirPath + aFile.getName();
            }
      }
      return sourceDirPath + "MobileServerUrl.js";
}

StringBuffer getMobileConfigURL(HttpServletRequest request){
      StringBuffer result = new StringBuffer();
      String val = request.getParameter("mobileConfigUrl");
      if (val != null){
            result.append(val);
      }
      return result;
}

Boolean isEDMChecked(HttpServletRequest request){
      Boolean result = false;
      String select[] = request.getParameterValues("debugMode");
      if (select != null && select.length > 0) {
            for (int i = 0; i < select.length; i++) {
                  if (select[i].equals("enable")) {
                        result = true;
                  }
            }
      }
      return result;
}

URL extractURL(StringBuffer config) throws URISyntaxException, MalformedURLException {
      URL result = null;
      Pattern p = Pattern.compile("http.+?(?=servlet|api)", Pattern.CASE_INSENSITIVE);
      Matcher m = p.matcher(config);
      if (m.find()) {
            result = new URL(URLDecoder.decode(m.group()));
      }
      else{
            result = new URL(URLDecoder.decode(config.toString().trim()));
      }
      return result;
}


String[] getDirs(String path){
      File file = new File(path);
      String[] directories = file.list(new FilenameFilter() {
            @Override
            public boolean accept(File current, String name) {
              return new File(current, name).isDirectory();
            }
          });
      return directories;
}

private final int[] BYTE_ORDER_MARK = {239, 187, 191};

private boolean startsWithBOM(File textFile) throws IOException {
      if(textFile.length() < BYTE_ORDER_MARK.length) {
            return false;
      }

      boolean result = false;
      int[] firstFewBytes = new int[BYTE_ORDER_MARK.length];
      InputStream input = null;

      try {
            input = new FileInputStream(textFile);
            for (int index = 0; index < BYTE_ORDER_MARK.length; ++index) {
                  firstFewBytes[index] = input.read();
            }
            result = Arrays.equals(firstFewBytes, BYTE_ORDER_MARK);
      }
      finally {
            input.close();
      }

      return result;
}

private void overwriteWithoutBOM(byte[] bytesWithoutBOM, File textFile) throws IOException {
      OutputStream output = null;
      try {
            output = new BufferedOutputStream(new FileOutputStream(textFile));
            output.write(bytesWithoutBOM);
      }
      finally {
            output.close();
      }
}

private void stripBomFrom(String textFile) throws IOException {
      File bomFile = new File(textFile);
      long initialSize = bomFile.length();
      long truncatedSize = initialSize - BYTE_ORDER_MARK.length;
      byte[] memory = new byte[(int)(truncatedSize)];
      InputStream input = null;

      try {
            input = new BufferedInputStream(new FileInputStream(bomFile));
            input.skip(BYTE_ORDER_MARK.length);
            int totalBytesReadIntoMemory = 0;
            while(totalBytesReadIntoMemory < truncatedSize) {
                  int bytesRemaining = (int)truncatedSize - totalBytesReadIntoMemory;
                  int bytesRead = input.read(memory, totalBytesReadIntoMemory, bytesRemaining);
                  if(bytesRead > 0) {
                        totalBytesReadIntoMemory = totalBytesReadIntoMemory + bytesRead;
                  }
            }
            overwriteWithoutBOM(memory, bomFile);
      }
      finally {
            input.close();
      }

      File after = new File(textFile);
      long finalSize = after.length();
      long changeInSize = initialSize - finalSize;
      if(changeInSize != BYTE_ORDER_MARK.length) {
            throw new RuntimeException("New File Size: " + changeInSize + " Expected change: " + BYTE_ORDER_MARK.length);
      }
}

String readFile(String filePath) throws FileNotFoundException, IOException {
      if (startsWithBOM(new File(filePath))) {
            stripBomFrom(filePath);
      }
      BufferedReader reader = new BufferedReader(new FileReader(filePath));
      StringBuilder sb = new StringBuilder();
      String line;
      while((line = reader.readLine())!= null){
          sb.append(line+"\n");
      }
      reader.close();
      return sb.toString();
}

void createFile(String path, String data) throws IOException {
      BufferedWriter writer = null;
      try {
            writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(path), "UTF-8"));
            writer.write(data);
      } finally {
            writer.close();
      }
}

void deleteFile(String path){
      File mFile = new File(path);
      if (mFile.exists()){
            mFile.delete();
      }
}

String getStringUrlFun(String url, String dirName){
      return "(function(){if(!mstrmojo.plugins." + dirName + ") mstrmojo.plugins."+ dirName +"={};mstrmojo.plugins." + dirName + ".MobileServerUrl=Object;window.getMobileServerURL=function getMobileServerURL(){return '" + url + "';}}());";
}

String getStringUrlFun1(String url, String dirName){
      return "mstrmojo.plugins." + dirName + ".MobileServerUrl=Object;window.getMobileServerURL = function(){return '" + url + "';}";
}

String getSavedMobileServerURL(ServletContext ctx) throws FileNotFoundException, IOException{
      String result = "";
      String fPath = getMobileServerFilePath(ctx, getPackageSampleChart());
      File mFile = new File(fPath);
       if (mFile.exists()){
            String fileContent = readFile(fPath);
            String line = fileContent;
            String pattern = "(mstrmojo.plugins."+ getPackageSampleChart() +".MobileServerUrl=)([^}]+(?<!Object).)";
            Pattern r = Pattern.compile(pattern);
            Matcher m = r.matcher(line);
            if (m.find()) {
                  Pattern p = Pattern.compile("http.+?(?=';})", Pattern.CASE_INSENSITIVE);
                  Matcher m2 = p.matcher(m.group(2));
                  if (m2.find()) {
                        result = m2.group();
                  }
            } 
      }
      return result;
}

Boolean isDebugModeEnabled(ServletContext ctx) throws FileNotFoundException, IOException{
      Boolean result = false;
      String path = getDebugFilePath(ctx);
      String content = readFile(path);
      Pattern p = Pattern.compile("(?<=var isVitaraMobileDebug = )true|false", Pattern.CASE_INSENSITIVE);
      Matcher m = p.matcher(content);
      if (m.find()){
            result = m.group().equalsIgnoreCase("true");
      }
      return result;
}

void setDebugFlag(ServletContext ctx, Boolean bool) throws IOException {
      String path = getDebugFilePath(ctx);
      String content = readFile(path);
      Pattern p = Pattern.compile("var isVitaraMobileDebug\\s*=\\s*true|var isVitaraMobileDebug\\s*=\\s*false", Pattern.CASE_INSENSITIVE);
      Matcher m = p.matcher(content);
      if (m.find()) {
            if (bool) {
                  content = m.replaceFirst("var isVitaraMobileDebug = true");
            }
            else {
                  content = m.replaceFirst("var isVitaraMobileDebug = false");
            }
      }
      createFile(path, content);
}
void updateMobileServerURL(String mServerURLString, String filePath, String dirName) throws IOException, URISyntaxException{
      String fileContent = readFile(filePath);
      String updatedFileString = "mstrmojo.plugins." + dirName +".MobileServerUrl=function getMobileServerURL(){return '" + mServerURLString + "';}();";
      String line = fileContent;
      String pattern = "(mstrmojo.plugins."+ dirName +".MobileServerUrl=)([^}]+(?<!Object).)";
      Pattern r = Pattern.compile(pattern);
      Matcher m = r.matcher(line);
      if (m.find()) {
            String final_str = line.replace(m.group(0), mServerURLString);
            fileContent = final_str;
      } 
      createFile(filePath, fileContent);
}

void insertMobileServerURL(String strUrl, ServletContext ctx) throws IOException, URISyntaxException, MalformedURLException {
      String[] dirs = getDirs(getPluginsRoot(ctx));
      if (!strUrl.isEmpty()) {
            for (int i = 0; i < dirs.length; i++){
                  if (belongsToPackage(dirs[i])) {
                        updateMobileServerURL(getStringUrlFun1(strUrl, dirs[i]), getMobileServerFilePath(ctx, dirs[i]).toString(), dirs[i]);
                  }
            }
      }
}

void removeMobileServerURL(ServletContext ctx) throws IOException{
      String[] dirs = getDirs(getPluginsRoot(ctx));
      for (int i=0; i<dirs.length; i++){
            if (belongsToPackage(dirs[i])) {
                  deleteFile(getMobileServerFilePath(ctx, dirs[i]));
            }
      }
}

%>
<html>
      <head> 
            <style>
                  .vtrButton {
                        width: 80px;
                        height: 25px;
                  }
                  .inputBox {
                        width: 350px;
                        height: 150px;
                        box-sizing: border-box;
                        border: 1px solid #e0e0e0;
                        border-radius: 4px;
                        background-color: #fcfcfc;
                        padding: 3px;
                        resize: none;
                  }
                  body {
                        font-family: Arial, Helvetica, sans-serif;
                        font-size: 14px;
                  }
                  .valid-url {
                        color: blue;
                  }
                  .label-hide {
                        display: none;
                  }
                  .label-show {
                        color: crimson;
                  }
            </style>
      </head>
      <body>
                 
      <%    
            String savedMobileServerUrl = "None";
            StringBuffer urlConfig = null;
            String errorLabelStyle = "label-hide";
            String errorMessage = "";
            try {
                  urlConfig = getMobileConfigURL(request);
                  if (!urlConfig.toString().trim().isEmpty()) {
                        if (!isValidURL(urlConfig.toString())) {
                              throw new MalformedURLException("invalid url");
                        }
                        URL mUrl = extractURL(urlConfig);
                        System.out.println(mUrl.toString());
                        insertMobileServerURL(mUrl.toString().trim(), application);
                  }
            }
            catch (MalformedURLException | URISyntaxException ex) {
                  errorLabelStyle = "label-show";
                  errorMessage = "Error Invalid URL" + ": " + urlConfig.toString();
                  System.out.println(ex.getMessage());
            }
            catch (IOException ex) {
                  System.out.println(ex.getMessage());
            }
            finally {
                  savedMobileServerUrl = getSavedMobileServerURL(application);
                  if (savedMobileServerUrl.isEmpty()) {
                        savedMobileServerUrl = "None";
                  }
            }
            
      %>
            
      <form ACTION="config.jsp">
            Mobile Configuration URL:<br>
            <textarea type = "text" name = "mobileConfigUrl" class="inputBox"></textarea><br>
            <div><br><label class="<%=errorLabelStyle%>"><%=errorMessage%></label></div>            
            <div><label>Configured: </label><label class="valid-url"><%=savedMobileServerUrl%></label></div><br>               
            <input class="vtrButton" type="submit" value="Submit">
      </form>
</body>
</html>